#!/bin/sh
#
# cleans old studies from the noarchive directory
#
# usage cleanNoArchive.sh
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

ArchiveTempDir="${ARCHIVE_TEMPDIR}"
Days2KeepArchiveTemp="${DAYS2KEEP_ARCHIVE_TEMP}"

[ -f ${ARCHIVE_VAR}/archive.cfg ] && . ${ARCHIVE_VAR}/archive.cfg

[ -z ${ArchiveTempDir} -o ! -d ${ArchiveTempDir} ] && exit 1

shopt -s extglob

[[ ${Days2KeepArchiveTemp} != [1-9]*([0-9]) ]] && exit 2

#--- clear old dirs with content (which must be at least as old as the directory)
for i in `find ${ArchiveTempDir}/ -type d -mtime +${Days2KeepArchiveTemp}` ; do
	rm -rf $i
done
