#!/bin/sh
#
# Component: archive
#
# Description:
#  OBSOLETE [7.0]
#   Obsoletes an archived study or DICOM object.
#
# Obsoleted studies/objects will not be shown on Archive page
# and will be disabled to be autoretrieved from the archive
#
# USAGE: see usage_()
#
# If no DICOM object given as argument, then the whole study will
# be obsoleted. If at least one DICOM object is listed, then only the
# listed DICOM objects will be obsoleted.
#
# Only obsoleting whole study will set obsolated flag (ARCHST=-100)
# in the Archive database
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

# if obs.sh is called directly:
# run as a task instead
if [ `basename $0` = "obs.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="obs.sh[$$]"

STUDY=$1
shift
OBSFILES=$@

# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "@Archive @Archive-PUT"
}

run_()
{
	if [ -z "$STUDY" ] ; then
		$LOGGER -p $LOG_FACILITY.err -t "$TAG" "Missing argument"
		return 125
	fi

	$TASKD_HOME/runjavacmd -c "0 archive.Obs -s \"$STUDY\" $OBSFILES" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}


# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print archive.Obs -s \"$STUDY\" $OBSFILES" -p "$JAVA_SERVER_PORT"
}

#
# Print value to be displayed on the WEB GUI
#
get_display_name_()
{
	echo "Sets study obsolete in EP archive" 
}

#
# Print resources used by the task 
#
get_resources_()
{
	echo "System.NET.@Archive.PUT"
}

#
# Print property value
#
get_property_()
{
	if [ "$PROPERTY" = "1PST" ] ; then
		echo -n "$study"
		return 0
	fi
	 
	if [ "$PROPERTY" = "1PPE" ] ; then
		echo -n "@Archive" 
		return 0
	fi

	get_def_property_
}

