
<%@page import="com.erad.pacs.modules.gwt.session.user.Group"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="com.erad.pacs.modules.gwt.descriptors.usermanager.LoginWithKeyModule"%>
<%@page import="cases.ActionjspKeystoreParam"%>
<%@page import="com.erad.pacs.toolbox.LoginServiceToolbox"%>
<%@
	page import = "java.io.*, java.sql.*, java.util.*, java.text.Format,
			com.erad.pacs.app.broker.table.internals.*,
			com.erad.pacs.app.broker.table.internals.imtables.*,
			com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*,
			com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			com.erad.pacs.common.interfaces.action.DcAction,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.connector.Connector,
			imagemed.util.*, imagemed.imsession.*, imagemed.types.flag.*,
			imagemed.imtables.queryqualifier.QueryQualifier, imagemed.summaries.*,
			com.erad.pacs.toolbox.KeystoreToolbox,
			java.security.KeyStore.PrivateKeyEntry"

%><%-- ----- Helper Functions ----- --%><%!// lock related stuff

static boolean bReentry = false;

synchronized static boolean lock() {
	if ( bReentry )
		return false;
	bReentry = true;
	return true;
}

static void unlock() {
	bReentry = false;
}
// end of lock related stuff

private static PrivateKeyEntry privateKey = null;

/**
 * Load private key from keystore only once and return instance.
 */
private static PrivateKeyEntry getPrivateKeyEntry() throws Exception {
	if (privateKey == null) {
		ActionjspKeystoreParam param = new ActionjspKeystoreParam();
		privateKey = KeystoreToolbox.loadKeystoreEntry( param.getKeystoreType(), param.getKeystorePath(  ), param.getKeystorePw(), param.getKeyAlias(), param.getKeyPw() );
	}
	return privateKey;
}

void checkAction( JspWriter out, HttpServletRequest request, HttpServletResponse response, RequestInfo requestInfo, CacheItem actionItem, boolean checkSlow ) throws ReflectiveOperationException, IOException, SessionException {
	
	UserManagerFacade um = Connector.getInstance().get( UserManagerFacade.Caller );
	Envelope userEnvelope = null;
	try {
		LoginWithKeyModule module = LoginWithKeyModule.ACTIONJSP;
		ActionjspKeystoreParam param = new ActionjspKeystoreParam();
		byte[] unsignedBytes = um.loginServiceRequest( module );
		// use getPrivateKeyEntry() so private key is loaded only once!
		byte[] signedBytes = KeystoreToolbox.sign( param.getSignatureAlg(), getPrivateKeyEntry().getPrivateKey( ), unsignedBytes );
		userEnvelope = um.loginServiceVerify( module, signedBytes, actionItem.user );
		if ( userEnvelope == null ) {
			throw new SessionException( "UserManager failed to verify " + module.getModuleName() + " signature!" );
		}
	}
	catch ( Throwable e ) {
		Helper.ERRORLOG( "action.jsp", "Executing actions on " + actionItem.user + "'s " + actionItem.list + " list failed: Login failed: " + e.getMessage(  )  );
		return;
	}

	Session userSession = um.checkEnvelope( request, response, userEnvelope );

	DcAction action = actionItem.actionClass.getDeclaredConstructor().newInstance();
	if (! userSession.getRights().hasRight( action.getReqRights() )) {
		Helper.ERRORLOG( "action.jsp", "Executing actions on " + actionItem.user + "'s " + actionItem.list + " list failed: No " + action.getReqRights() + " right"  );
		return;
	}
	
	out.println( "<B>" + action.getName() + "</B><BR>" );
	// listname.ip.ip.ip.ip.xxx

	action.setList( actionItem.user, actionItem.list );

	if ( !userSession.getRights().hasRight( PacsRight.RestrictedQuery ) ) {
		//re-check slow query
		
		if ( checkSlow ) {
			String mesName = "slowAction-" + actionItem.user + "-" + actionItem.list + "-"+ action.getName();
			//message must be deleted, when the query is not slow!
			// because message doesn't do any deleting
			try {
				QueryQualifier qq = new QueryQualifier();
				String qualif = qq.qualifyFilters( userSession, new WorklistTableParamsImpl( userSession, actionItem.user, actionItem.list, false, null ), true, true );
				if( !QueryQualifier.GOOD.equals( qualif ) ) {
					String problem = LocalizedMessage.getCompoundMessage( "QQ_BAD_QUERY_ACTION_RUNNING", new Format[]{ null, null, null }, new Object[]{ actionItem.user, actionItem.list, action.getName() }, false );
					out.print( problem + "<BR>\n" );
					List<String> mes = new ArrayList<String>();
					mes.add( "<center>" + problem + "</center>" );
					IMMessage.createMessage( userSession, mesName, mes, null, new String[]{ Group.ADMIN_GROUP_ID }, 10000000, 1440, false, true );
				}
				else {
					IMMessage.delete( mesName );
				}
			}
			catch( Throwable th ) {
				Helper.defaultCatch( th );
			}
		}
	}

	
	out.print( "checking " + actionItem.user + "'s " + actionItem.list + "<BR>\n" );
	UserListImpl.acquireListLock( actionItem.user, actionItem.list );
	try {
		out.println( action.checkAction( userSession, request, requestInfo ) );
	}
	catch ( Exception e ) {
		try {
			Helper.ERRORLOG( "action.jsp", "Checking/executing actions on " + actionItem.user + "'s " + actionItem.list + " list failed: " + Helper.throwable2String( e ) );
			out.println( Helper.throwable2String( e ) );
		}
		catch ( Exception ex ) {
		}
	}
	finally {
		UserListImpl.releaseListLock( actionItem.user, actionItem.list );
	}
	
	
/*

	This was within checkUser() {}
	Probably could work from the Summary SQL table
		
	// check summaries
	for( int i = 0; i < GenericUserListImpl.LIST_SUBDIRS.length; i++ ) {
		String[] filterNames = UserListImpl.getFilterNames( userName, i );
		Summary[] sums = SummaryManager.getSummaries( i );
		for( int j = 0; j < filterNames.length; j++ ) {
			UserListImpl.acquireListLock( userName, i, filterNames[ j ] );
			try {
				for( int k = 0; k < sums.length; k++ ) {
					sums[ k ].checkAndRun( userSession, sessita.getRequestInfo(  ), userName, i, filterNames[ j ] );
				}
			}
			catch( Exception e ) {
				Helper.defaultCatch( e );
			}
			finally {
				UserListImpl.releaseListLock( userName, i, filterNames[ j ] );
			}
		}
	}
*/	
	
	//TODO logoff user without logging
}

%><%
	if ( !lock() ) {
		Helper.INFOLOG( "action.jsp could not get lock (cannot reenter)" );
		out.println( "cannot reenter" );
		return;
	}
	try {
		Helper.INFOLOG( "action.jsp start" );

		if ( ! LoginServiceToolbox.checkServerIp( request.getRemoteAddr() ) ) {
			// when called fom remote IP check for a user session 
			UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
			userManager.getSessitaSession( request, response );
		}

		RequestInfo requestInfo = new RequestInfo(request);		
		
		//sess.createIMRequest( false );
		
		//is.sessionVariables.setProperty("actionJsp", "true"); // TODO

		boolean checkSlow = false;
		GregorianCalendar now = new GregorianCalendar();
		String actDate = Helper.calcDayStr( now );
		try {
			String envq = "select * from Env";
			ResultSet rs = IMEnv.getDB().createStatement().executeQuery( envq );
			if( rs.next( ) ) {
				String lastDate = rs.getString( "SLOWQUERYCHECK" );
				if( !actDate.equals( lastDate ) ) {
					checkSlow = true;
				}	
			}
		}
		catch( Throwable th ) {
			Helper.defaultCatch( th );
		}


		List<CacheItem> actions = ActionCache.getActions();
		for ( CacheItem item : actions ) {
			checkAction( out, request, response, requestInfo, item, checkSlow );
		}
		
		Helper.DEBUG( "checking all summaries" );
		UserManagerFacade um = Connector.getInstance().get( UserManagerFacade.Caller );
		Envelope envelope = null;
		try {
			envelope = LoginServiceToolbox.loginService(um, new ActionjspKeystoreParam(), null);
		}
		catch ( Exception e ) {
			Helper.ERRORLOG( "action.jsp", "Summary checking: Login failed: " + e.getMessage(  )  );
			return;
		}

		Session actionSession = um.checkEnvelope( request, response, envelope );
		SummaryManager.checkAndRunAll( actionSession, requestInfo );

		if ( checkSlow ) {              
			String envu = "update Env set SLOWQUERYCHECK='" + actDate + "'";
			IMEnv.getDB().createStatement().execute( envu );
		}
	}
	finally {
		Helper.INFOLOG( "action.jsp end" );
		unlock();
	}
%>