<%-- 
 * Component: cases
 *
 * Description:
 *   Prints DICOM and and database dump for an object
 *
 * Parameters:
 *
 *  @param cStudy   Study Instance UID of the study the object to be dumped belongs to
 *  @param cFname   File name of the object to be dumped (relative to study directory)
 *  @param pName    Patient's Name of the study
 *  @param cPar     Type of the dump to print ('DICOM', 'Processed', 'Database')
 *
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"
    
%><%@
	page import="java.sql.*, java.text.Format,
		com.erad.pacs.modules.gwt.session.right.PacsRight,
		com.erad.pacs.connector.Connector,
		com.erad.pacs.services.usermanager.client.Session,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		com.erad.pacs.common.libs.RequestInfo,
		imagemed.util.*, imagemed.imsession.*, imagemed.repohandler.*,
		imagemed.http.tabs.TabBean"
              
%><%-- ************************* INIT ************************* --%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
	RequestInfo requestInfo = new RequestInfo(request);

	String cStudy = request.getParameter("cStudy");
	String cFname = request.getParameter("cFname");
	String pName = request.getParameter("pName");
	String cPar = request.getParameter("cPar");

	String thisPage = "dump.jsp";

	boolean hasDumpRight = sess.getRights().hasRight( PacsRight.Dump );

	if (!hasDumpRight) {
		String dump = (cPar == null) ? "Dump " : cPar + " dump";
		out.println("<HTML><HEAD><TITLE>" + LocalizedMessage.getCompoundMessage( "CASES_DUMP_NOT_AVAILABLE", new Format[] { null }, new Object[] { dump }, false ) + "</TITLE>");
		TabBean.writeStyleOnly( response.getWriter() );
		com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( response.getWriter() );
		out.println("</HEAD><BODY><CENTER><BR><BR>");
		MessageBox mb = new MessageBox(LocalizedMessage.getCompoundMessage( "CASES_DUMP_NOT_AVAILABLE", new Format[] { null }, new Object[] { dump }, false ), "80%");
		mb.setMessage("<BR><BR><H3>" + LocalizedMessage.getCompoundMessage( "CASES_DUMP_NOT_AVAILABLE_MSG", new Format[] { null }, new Object[] { dump }, false ) + "</H3><BR><BR>");
		mb.addButton(new Button("javascript:window.close();", "BUTTON_OK", "BUTTON_OK"));
		mb.print( response.getWriter() );
		out.println("</CENTER></BODY></HTML>");
		return;
	}


	int vN = 0; // counter - which is the current pic?
	int vS = 0; // counter - which seria does contain the current pic?
	boolean gotCurrent = false; //  It will be true when the cFname will be found.
	String vFnext = null;
	String vFcurrent = null;
	int vScurrent, vNcurrent, vN9current;
	vScurrent = vNcurrent = vN9current = 0;

	Connection IMDB = IMEnv.getDB();
	Statement st = IMDB.createStatement();
	String stud = Helper.sqlEncode(cStudy);
	String stStr = "SELECT DISTINCT SERNUMBER,SERIUID FROM Dcobject WHERE STYIUID='" + stud + "' ORDER BY SERNUMBER,SERIUID";
	ResultSet resSeries = st.executeQuery(stStr);
	while (resSeries.next() && !gotCurrent) {
		// *** Counting series and detect current seria ***
		vS++;
		vN = 0;
		String vSeries = resSeries.getString("SERIUID");

		Statement st2 = IMDB.createStatement();
		stStr = "SELECT IMNUMBER,FNAME,IROWS,ICOLUMNS,NOOFFRAMES FROM Dcobject " + "WHERE STYIUID='" + stud + "' AND SERIUID='" + vSeries + "' ORDER BY IMNUMBER,FNAME";
		ResultSet resPics = st2.executeQuery(stStr);
		while (resPics.next()) {
	// *** Counting pictures, detect current and next pic. ***
	int vN9 = resPics.getInt("NOOFFRAMES") + vN;
	vN++;
	String vF = resPics.getString("FNAME");

	if (gotCurrent) {
		//  this record contains the next fileName
		vFnext = vF;
		break;
	}

	if (cFname.equals(vF)) {
		//  this record describes the curent
		gotCurrent = true;
		vFcurrent = vF;
		vScurrent = vS;
		vNcurrent = vN;
		vN9current = vN9;
		vN = vN9;
	}
		}
	}

	String hRefNext = null;
	if (vFnext != null) {
		hRefNext = "<A href=\"JavaScript:Dump_( '" + vFnext + "' )\";>Next</a>";
	}
	
%><%-- ************************* HTML *************************
--%><HTML>
<HEAD>
  <TITLE>
    <%=pName + " - " + cPar + " Dump " + vScurrent + " " + vNcurrent + " - " + requestInfo.getHttpxHost()%>
  </title>
  <SCRIPT Language="JavaScript">
    function Dump_( pNext ) {
      dat = new Date();
      tim = dat.getTime();
      window.open( '<%=thisPage%>?cStudy=<%=cStudy%>&cFname=' +pNext + '&pName=<%=Helper.URLEncodeUTF8(pName)%>&cPar=<%=cPar%>',
                    tim, 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=640,height=360' );
    }
  </script>
<%	imagemed.http.tabs.TabBean.writeStyleOnly( response.getWriter() );%>
</head>
<BODY><P>
  <TABLE width="100%">
    <TR>
      <TD width="10%">
        <FONT face="Arial,Helvetica,Universe" size=4><B>
        <%=vScurrent%>&nbsp;<%=vNcurrent%>
<%
	if (vNcurrent != vN9current) {
%><%="&nbsp;-&nbsp;"%><%=vN9current%><%
	}
%>
        <BR><%=cPar%>
      </td>
      <TD align="center">
        <FONT face="Arial,Helvetica,Universe" size=6><B>
        <%=pName%>
      </td>
      <TD align="right" width="10%">
        <FONT face="Arial,Helvetica,Universe" size=4><B>
<%
	if (vFnext != null)
		out.println(hRefNext);
%>
      </td>
    </tr>
  </table>

<%
	if (cPar.equals("Database")) {
		// ****************************** Database Dump

		ResultSetMetaData rsmd;

		stStr = "SELECT * FROM Dcstudy WHERE STYIUID='" + stud + "'";
		ResultSet styRec = st.executeQuery(stStr);
		if (styRec.next()) {
%>
      <BR>
        <CENTER><FONT face="Arial,Helvetica,Universe" size=4><B>
          STUDY Record
        </b></font></center>
      <BR>
<%
			out.println("<TABLE>");
			rsmd = styRec.getMetaData();
			for (int i = 1; i <= rsmd.getColumnCount(); i++) {
%><TR><TD><%=rsmd.getColumnLabel(i)%></td><TD><%=Helper.htmlEncode(styRec.getString(i))%></td></tr><%
			}
			out.println("\n</TABLE>");
		}


		String curFileName = Helper.sqlEncode(vFcurrent);
		stStr = "SELECT * FROM Dcobject WHERE FNAME='" + curFileName + "' AND STYIUID='" + stud + "'";
		ResultSet objRec = st.executeQuery(stStr);

		if (objRec.next()) {
%>
      <BR>
        <CENTER><FONT face="Arial,Helvetica,Universe" size=4><B>
          OBJECT Record
        </b></font></center>
      <BR>
<%
			out.println("<TABLE>");
			rsmd = objRec.getMetaData();
			for (int i = 1; i <= rsmd.getColumnCount(); i++) {
%><TR><TD><%=rsmd.getColumnLabel(i)%></td><TD><%=Helper.htmlEncode(objRec.getString(i))%></td></tr><%
			}
			out.println("\n</TABLE>");
		}

	} // ************************************* End of Database Dump

	else {
		String vFile;
		if (cPar.equals("Processed")) { //  Processed Dump
			vFile = RepositoryHandler.getLocation(Repository.PROCESSED, cStudy) + "/" + vFcurrent;
		}
		else { //  DICOM Dump
			vFile = RepositoryHandler.getLocation(Repository.DICOM, cStudy) + "/" + vFcurrent;
		}
		String[] env = {("HOME=" + IMEnvBase.getEnv("HOME"))};
		String[] cmd = new String[2];
		cmd[0] = IMEnvBase.getEnv("DCMTK_HOME") + "/bin/dcmdump";
		cmd[1] = vFile;
		out.println("<PRE>" + Helper.htmlEncode(Helper.runCommand(cmd, env)) + "</PRE>");
	}

	if (vFnext != null) {
%>
    <DIV align="right">
    <FONT face="Arial,Helvetica,Universe" size=4><B>
    <%=hRefNext%>
<%
	}
%>

</body>
</html>
