<%--
 * Component: cases
 *
 * Description:
 *  Interface for locking/unlocking studies used by the viewer and remote dotcom servers.
 *
 * Parameters:
 *
 *   cStudy        Study Instance UID
 *   cOp           Lock operation: Lock, Break, CheckLock, IsLocked, Unlock (= default), lockOwners, None
 *   cClose        true - indicates the study is being closed in the viewer
 *                    in case of cClose=true only Unlock and None are the valid lock operations
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%>

<%@page import="com.erad.pacs.helper.RequestHelper"%>
<%@page import="com.erad.pacs.services.usermanager.service.internal.SessionToolbox"%>
<%@page import="com.erad.pacs.modules.gwt.exception.SecurityException"%>
<%@page import="java.net.UnknownHostException"%>
<%@page import="imagemed.jsputil.LocalIp"%>
<%@page import="java.io.File"%>
<%@page import="java.net.InetAddress"%>
<%@page import="imagemed.imsession.IMEnvBase"%>
<%@page import="imagemed.imsession.IMEnv"%>
<%

String security = IMEnv.getConfigProperty( IMEnv.SECURITY_REC, "optSecure", IMEnv.INSECURE );
boolean secure = false;

//almost the same as SessionToolbox.isIpSecure, could be unified
if ( security.equals( IMEnv.AUTO ) ) {
	out.println("Security setting is on AUTO<br/>");
	String secConf = IMEnvBase.getEnv( "CONF" ) + "/secureIPs.cfg";
	String regIP;
	try {
		regIP = RequestHelper.getIp(request);
		out.println("Client IP is : " + regIP + "<br/>");
		if ( new File( secConf ).exists() ) {
			secure = !LocalIp.isLocal( regIP, secConf );
		}
		else {
			secure = !LocalIp.isLocal( regIP );
		}
	}
	catch ( UnknownHostException e ) {
		out.println("Unknown host<br/>");
		secure = false;
	}
}
else {
	secure = ( security.equals( IMEnv.SECURE ) );
}

out.println("Protocol should be: " + (secure ? "https" : "http") + "<br/>");

if ( secure && !request.isSecure() ) {
	out.println("This request would be redirected to https<br/>");
}

if ( !secure && request.isSecure() ) {
	out.println("This request would be redirected to http<br/>");
}


%>