#!/bin/sh
#
# usage: printPage.sh URL [params_for_lp]
#

. ~/etc/setenv.sh

URL=$1
shift

if [ "$URL" == "" ]; then
	echo "The first parameter should contain the URL to be printed."
	return 1
fi

output="/tmp/printrep.$$.ps"

[ -f $CONF/printRep.cfg ] && . $CONF/printRep.cfg

if [ "true" == "$forceHtml2Ps" -o "`which gnome-web-print`" == "" -o ! -f "$XVFB_RUN" ]; then 
	echo "
		@html2ps {
			option {
				toc: 0
				titlepage: 0
				hyphenate: 0
			}
			footer {
				left: \$T;
				right: \"Page \$N\";
				center: \"\";
			}
		}
	" >/tmp/printer.html2ps.1.conf.$$

	echo "
		@html2ps {
			package {
				geturl: \"$CURL_HOME/bin/curl -i -L\"
			}
		}
	" >/tmp/printer.html2ps.2.conf.$$

	CONFFILE="/tmp/printer.html2ps.1.conf.$$"

	if [ -f "$CONF/html2psrc" ] ; then
		CONFFILE="${CONFFILE}:${CONF}/html2psrc"
	fi

	CONFFILE="${CONFFILE}:/tmp/printer.html2ps.2.conf.$$"

	echo "${URL}" >/tmp/url.txt 

	html2ps -o $output -f "$CONFFILE" "http://127.0.0.1:$HTTP_PORT${URL}" >/tmp/printrep.log.$$ 2>&1

	rm /tmp/printer.html2ps.1.conf.$$
	rm /tmp/printer.html2ps.2.conf.$$
else
	export DISPLAY="$XVFB_DISPLAY"
	gnome-web-print "http://127.0.0.1:$HTTP_PORT${URL}" $output >/tmp/printrep.log.$$ 2>&1
fi

/usr/bin/lp $@ $output

rm $output
